/*
 * Copyright 2014, General Dynamics C4 Systems
 *
 * This software may be distributed and modified according to the terms of
 * the GNU General Public License version 2. Note that NO WARRANTY is provided.
 * See "LICENSE_GPLv2.txt" for details.
 *
 * @TAG(GD_GPL)
 */

#ifndef __ARCH_LINKER_H
#define __ARCH_LINKER_H

#include <util.h>

/* code that is linked to physical addresses */
#define PHYS_CODE SECTION(".phys.text")

/* data that is linked to physical addresses */
#define PHYS_DATA SECTION(".phys.data")

/* bss data that is linked to physical addresses */
#define PHYS_BSS SECTION(".phys.bss")

/* code that is only used during kernel bootstrapping */
#define BOOT_CODE SECTION(".boot.text")

/* node-local data that is only used during kernel bootstrapping */
#define BOOT_DATA SECTION(".boot.data")

/* node-local bss data that is only used during kernel bootstrapping */
#define BOOT_BSS SECTION(".boot.bss")

#endif
